#include "mode.hh"

bool Mode::needsparm() const
{
    return mode=='b' || mode=='e'
        || mode=='k' || (!nega && mode=='l')
        || mode=='o' || mode=='v'
        || mode=='I' || mode=='O';
}

bool Mode::operator== (const Mode &b) const
{
    return nega == b.nega && mode == b.mode && parm == b.parm;
}

void Mode::setparm(const string &s)
{
    parm = s;
}

#include <cstdio>
using std::printf;
void Mode::dump() const
{
    printf("%c%c", nega?'-':'+', mode);
    if(needsparm())printf(" %s", parm.c_str());
}

string strgroup(const list<Mode> &l)
{
    string s;
    
    char sign=0;
    list<Mode>::const_iterator i;
    for(i=l.begin(); i!=l.end(); ++i)
    {
        const Mode &m = *i;
        if(m.isnega()) { if(sign!='-')s += (sign='-'); }
        else { if(sign!='+')s += (sign='+'); }
        s += m.getmode();
    }
    for(i=l.begin(); i!=l.end(); ++i)
    {
        const Mode &m = *i;
        if(m.needsparm())
        {
            s += ' ';
            s += m.getparm();
        }
    }
    
    return s;
}

bool Mode::compatible(const Mode &b) const
{
    return true;
}
