#include <string>
#include <list>

using std::string;
using std::list;

#include "classes.hh"

class Mode
{
    defclassvar(bool,   nega, bool,           isnega)
    defclassvar(char,   mode, char,           getmode)
    defclassvar(string, parm, const string &, getparm)
public:
    Mode(bool n, char m, const string &p = ""): nega(n), mode(m), parm(p) { }
    
    void setparm(const string &s);
    
    bool needsparm() const;
    bool operator== (const Mode &b) const;
    inline bool operator!= (const Mode &b) const { return ! operator==(b); }
    
    static char cmdchar() { return 'M'; }
    static unsigned groupcount() { return 3; }
    bool compatible(const Mode &b) const;
    
    void dump() const;
};

extern string strgroup(const list<Mode> &);
